//* Idea and code is fom here: http://www.lazarusforum.de/viewtopic.php?f=11&t=11192&sid=168469750a6901511652224a2b45858b
//* M.\\/eber  (only added the IDE)   Date : 09.11.2017
//* Calculates the number of PI with 10'000 digits
//* Written on a Raspberry 3 (stretch)
//* With Lazarus : v1.6.2

unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnCalculatePI: TButton;
    Memo1: TMemo;
    ProgressBar1: TProgressBar;
    procedure btnCalculatePIClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnCalculatePIClick(Sender: TObject);
Const
  stellen=10000;

var
  r,p:string;
  m,i,j,u,z:integer;
  c : Array[0..10*(Stellen+1) Div 3] of integer;

begin
  ProgressBar1.min := 0;
  ProgressBar1.max := stellen;
  btnCalculatePI.enabled := False;
  Memo1.Lines.add('Calculation started');

  r:='';
  p:='';
  m:=10*(Stellen+1) Div 3;
  For i:=1 To m Do c[i]:=2;
  For j:=0 To Stellen Do Begin
    ProgressBar1.position := j;
    Application.ProcessMessages;
    u:=0;
    For i:=m DownTo 2 Do Begin
      z:=10*c[i]+u;
      c[i]:=z Mod (i*2-1);
      u:=z Div (i*2-1)*(i-1)
    End;
    z:=10*c[1]+u;
    c[1]:=z Mod 10;
    u:=z Div 10;
    If u<=8 Then Begin
      r:=r+p;
      p:=Chr(48+u);
    End;
    If u=9 Then p:=p+Chr(48+u);
    If u=10 Then  Begin
      For i:=1 To Length(p) Do Begin
        Val(p[i],z,u);Inc(z);
        If z=10 Then z:=0;
        p[i]:=Chr(48+z)
      End;
      p:=p+'0';
    End
  End;
  p:=r[1]+'.'+Copy(r,2,Length(r))+p;

  Memo1.Lines.add(p);
  btnCalculatePI.enabled := True;
end;


end.

